var markersArray = [];

function addMarker(marker) {
  marker.setMap(map);
  markersArray.push(marker);
    google.maps.event.addListener(marker, 'dblclick', function(event) {
    	clearTimeout(update_timeout);
        onDblClickMarker(marker);
    });
    
    google.maps.event.addListener(marker, 'click', function(event) {
    	update_timeout = setTimeout(function(){
        	onClickMarker(marker);
    	}, 200); 
        
    });
    
    google.maps.event.addListener(marker, 'dragend', function() {
        onDragMarker(marker);
    });
}
/*
function removeMarker(marker) {
	marker.setMap(null);
	var i=markersArray.indexOf(marker);
	if (i!=-1) markersArray.remove(i);
}
*/
// Removes the overlays from the map, but keeps them in the array
function clearOverlays() {
  if (markersArray) {
    for (i in markersArray) {
      markersArray[i].setMap(null);
    }
  }
}

// Shows any overlays currently in the array
function showOverlays() {
  if (markersArray) {
    for (i in markersArray) {
      markersArray[i].setMap(map);
    }
  }
}

// Deletes all markers in the array by removing references to them
function deleteOverlays() {
  if (markersArray) {
    for (i in markersArray) {
      markersArray[i].setMap(null);
    }
    markersArray.length = 0;
  }
}

function fitToAll()
{
    var bound = new google.maps.LatLngBounds();
    for(var i in markersArray)
    {
        bound.extend(markersArray[i].getPosition());
    }
    map.fitBounds(bound);
    map.setZoom( Math.min(16,map.getZoom()) );
}

function recenterMap()
{
	var bound = map.getBounds();
	if (bound == undefined) return 
	for(var i in markersArray)
    {
    	if (bound.contains(markersArray[i].getPosition()))
    	{
    		return;
    	}
    }
    fitToAll();

}
