// LISTE D'ITEM  =========================================

(function( $ ) {
  $.widget( "ui.list",$.ui.portlet,  {
  	
  	options: { 
      items: [],
      style_libelle: "width:130px;display:inline-block;font-weight: bold; ",
      css_li: "margin: 0 1px 1px 1px; padding: 0.4em; font-size: 1.2em;"
    },
  	
    // Set up the widget
    _create: function() {
    	var self = this;

        $.ui.portlet.prototype._create.call(this);

    	var el=self.element.find(".portlet-content");
        el.append("<ul id='sortable' class='portlet-ul' style='list-style-type:none;'>");
    	jQuery.each(this.options.items,function(index,item)
    	{
            self._addItem(item);
    	});
    	
    	this._saveObject();
    },

    _edit: function()
    {
        $.ui.portlet.prototype._edit.call(this);
        this.element.find("ul").sortable({placeholder: "ui-state-highlight",delay: 300});
    },

    _canceledit : function()
    {
        $.ui.portlet.prototype._canceledit.call(this);
        this.element.find("ul").sortable("destroy");
    },

    addItem: function(data) {


        for (i=0;i<this.jsonTree.items.length;i++)
        {
            item=this.jsonTree.items[i]
            if (item.libelle==data.libelle && item.format==data.format) return
        }


        this._addItem(data) ;
        this.jsonTree.items.push(data);
    },

    _addItem: function(data) {
        var el=this.element;
        el=el.find("ul");
        s="<button class='toolbtn editbtn' style='padding-right: 2px; display: none;'>Supprimer</button>";
        l="<div style='"+this.options.style_libelle+"'>"+data.libelle+"</div>";
        d="<div style='display:inline-block;'>"+data.format+"</div>" ;
        el.append("<li style='"+this.options.css_li+"'>"+s+l+d+"</li>");
        // Ajout du bouton pour supprimer un item
        el.find("button").button({ "text": false,  "icons": {primary:'ui-icon-trash'} }).click(
            function(){$(this).parent().remove();}
        );

    },

    drop: function(data) {
        val=data.attr.format.replace(/"/g,"").replace(/{/g,"{~");
        this.addItem({libelle:data.attr.nom,format: val})
        this._edit();

    } ,
    
    _callback: function(obj,valeur)
    {
    	$(obj).find("div:eq(1)").html(valeur);
    },

    _evaluer : function (entity)
    {
        if (!$.ui.portlet.prototype._evaluer.call(this,entity)) return;

        // Récupération des éléments à évaluer
        formats=[];
        var self=this;
        $("#"+self.element.context.id+" li").each(function(i){
            self.arrEvaluer.push({obj:this});
            formats.push(self.jsonTree.items[i].format);
        });

        evaluation(this.element,entity,self.arrEvaluer,formats,this._callback) ;
       
    },

    _save: function()
    {
        sav=$.ui.portlet.prototype._save.call(this);
        if (sav==null) return;
        sav.type="ui.list";
        arr=[] ;
        ul=this.element.find("ul");
        $("#"+this.element.context.id+" li").each(function(){
            arr.push({
                      libelle:$(this).find("div:eq(0)").text(),
                      format:$(this).find("div:eq(1)").text()
                     });
        });
        sav.items=arr;
        sav.style_libelle= this.options.style_libelle;
        return sav;
    },

    _load: function(json)
    {
        var self=this;
        $.ui.portlet.prototype._load.call(this,json);

        this.options.style_libelle=json.style_libelle;

        ul=this.element.find("ul");
        $("#"+this.element.context.id+" li").each(function(){
            $(this).remove();
        });

        $.each(json.items, function(i, v){
            self._addItem(v)
        });

        this.jsonTree=json;
    }

  	
  	
});
}( jQuery ) );
// ==============================================================
