
(function( $ ) {
  $.widget( "ui.timeline",$.ui.portlet,  {
  	
  	options: { 
  	  nom:'Graphique',
  	  options:{legende:true},
      composantes: [],
      style:"border:none;background: none; padding:2px;overflow-y:none"
    },
    
    entity: "",
    reload:false,
  	
    // Set up the widget
    _create: function() {
    	var self = this;
		this.options.titre.afficher=false;
		
		var el=this.element;
		el.css({width:400,height:300});

        $.ui.portlet.prototype._create.call(this);
        var el=self.element.find(".portlet-content");
        el.append("<div id='"+self._graphid()+"' class='portlet-timeline' style='width:90%; height:200px'>");
        
        this._saveObject();
	
    },

    drop: function(data) {
        composante=data.attr.fullname;
        for (i=0;i<this.options.composantes.length;i++)
        {
            item=this.options.composantes[i]
            if (item.composante==composante) return
        }
        
        this.options.composantes.push({composante:composante});
        this.reload=true;
        this._evaluer(this.entity); 

    } ,
    
    _OnResized : function ()
    {
        $.ui.portlet.prototype._OnResized.call(this);
        this.reload=true;
        this._evaluer(this.entity); 
    },
    
    _graphid: function()
    {
    	return this.element[0].id+"_timeline"	
    },
    
    _evaluer : function (entity)
    {
        if (!$.ui.portlet.prototype._evaluer.call(this,entity)) return;
        
        var self=this;
        this.entity=entity;
        
        url='/entity/'+entity+'/valeursData'
        getComposantesGraphValues(url,this.options.composantes,-1,-1,function(json,yaxes,series)
        {
        	$("#"+self._graphid()).css("height",self.element[0].clientHeight)
        	chart=RenderGraph(self._graphid(),self.options.nom,yaxes,series,self.options.options,function(e){
        		self.element.animate({opacity:1,duration:'fast'});
        		if (!self.reload) $("#"+self._graphid()).css("opacity",1);
        		else $("#"+self._graphid()).css("opacity",0.1);
        		self.reload=false
        	})	
        })

    },
    
    _edit: function()
    {
    	$.ui.portlet.prototype._edit.call(this);
    	$("#"+this._graphid()).css("opacity",0.1);
    },

    _save: function()
    {
        json=$.ui.portlet.prototype._save.call(this);
        if (json==null) return;
        json.type="ui.timeline";
        json.nom=this.options.nom;
        json.composantes=this.options.composantes;
        json.options=this.options.options;
        return json;
    },

    _load: function(json)
    {
        var self=this;
        $.ui.portlet.prototype._load.call(this,json);
        this.options.nom=json.nom;
        this.options.options=json.options;
        this.options.composantes=[]
        for (i=0;i<json.composantes.length;i++)
        {
            item=json.composantes[i]
            if (item.fullname=="") continue;
            this.options.composantes.push(item);
        }
        json.composantes=this.options.composantes
        
        this.jsonTree=json;
    }

});
}( jQuery ) );
// ==============================================================

