# -*- coding: utf-8 -*-
class EntityController < ApplicationController
 
  include Entities
 
  #before_filter :unset_menu  
  before_filter :getcomposante 
  before_filter :recupererlesdates
  
  
  
  def recupererlesdates
    if params[:dstart]=="-1" ||  params[:end]=="-1"
      @dend=Time.now
      @dstart=@dend  - 3600*24*30*12 # 1 an 
    else
      @dstart=Time.at(params[:dstart].to_i)
      @dend=Time.at(params[:dend].to_i)    
    end
  end
  
  def getcomposante
    params[:rawcomposanteid]=params[:composanteid]
    
    # Si la composante dispose d'un identifiant d'uid de serveur (ie: <uid>-<composanteid>)
    info=getInformationFromParameter(params[:composanteid])
    params[:composanteid]=info[:cid]
    params[:uid]=info[:uid]
    @entity=params[:id]
    @nodesToOpen=""
    
    e=Entities.get(@entity)
    @entity_name="[#{e.uid}] #{e.libelle}"
    
    # Vérification que le user a le droit de voir l'entité
    if ! User.current.hasEntity? @entity
      logger.info("ENtité '#{@entity}' non autorisé")
      unauthorized; return false    
    end
    
    # Si cid est passé en paramètre on va ouvrir, toutes les noeuds parents
    if !params[:cid]
      #params[:cid]=User.current.getEntityAction(@entity)  
      params[:cid]=User.current.currentComposante()
      c=Composante.find_by_id(params[:cid])
      if c
        if !c.inMaster?
          cuid=Master.serveurUidsForComposante(c)
          vuid=Value.getValue(@entity,cuid)
          if vuid != nil 
            uid=vuid.valeur  
            params[:cid]="#{uid}#{Composante::UID_SEP}#{params[:cid]}"
          end
        end  
      end
    end
    
    if params[:cid]
      info=getInformationFromParameter(params[:cid])
      c=Composante.find_by_id(info[:cid])
      uid=info[:uid]
      
      # Récupération des parents
      if c!=nil && c.isReadable?
        parents=[c.id]
        while c.parent!=nil && c.parent.id != 1
          parents<<c.parent.id
          c= c.parent  
        end  
        
        parents.reverse!
        
        if uid != @entity 
          @nodesToOpen=parents.collect { |x| "'#{uid}-#{x}'" }.join(",")
        else
          @nodesToOpen=parents.collect { |x| "'#{x}'" }.join(",")
        end 
      end
    end

    User.current.current_entity=@entity
  end
  
  def getInformationFromParameter(valeur)
    valeur=valeur.to_s
     # Si la composante dispose d'un identifiant d'uid de serveur (ie: <uid>-<composanteid>)
    if valeur !=nil and valeur.include? Composante::UID_SEP
      cid=valeur.split(Composante::UID_SEP)[1]
      uid=valeur.split(Composante::UID_SEP)[0]
    else
      cid=valeur
      uid=params[:id]
    end 
    return {uid:uid,cid:cid} 
  end
  
  def gps
    @entity=params[:id]
    if ! User.current.gps?
      unauthorized; return false
    end
    
    Value.setComposanteValue(uid: @entity,
                             composante: Master::LAT_PRECIS,
                             valeur: params[:lat], source: "Repositionné par <user>#{User.current.uid}</user>")
    Value.setComposanteValue(uid: @entity,
                             composante: Master::LON_PRECIS,
                             valeur: params[:lon], source: "Repositionné par <user>#{User.current.uid}</user>")
    
    Entities.clear(@entity)
    flash.now[:notice]="La nouvelle position a été sauvegardée"
    flasher
    
  end
 
  def index
    @entity=params[:id]
    action=params[:redirect]
    @current_entity=User.current.showEntity(@entity)
    perspective=Perspective.currents.first()
    User.current.save
    respond_to do |format|
      format.html { 
                    if action == "composantes" || action == "historiques" || action == "journal"
                      redirect_to  :controller => "entity",  :action => action,:id => @entity,:cid => params[:cid]
                      return
                    end
                    
                    if action == "perspective"
                      redirect_to  :controller => "perspective",  :action => 'default',:id => @entity ,
                      :pid => params[:pid]
                      return
                    end
                    
                    # Sinon il y a une prspective apr défaut 
                    if User.current.profile.perspective != nil
                      redirect_to  :controller => "perspective",
                                   :action => 'default',
                                   :id => @entity ,
                                   :pid => User.current.profile.perspective.id  
                      return
                    # Sinon on prend la permière perspective 
                    elsif perspective!=nil  
                      redirect_to  :controller => "perspective",
                                   :action => 'default',
                                   :id => @entity ,
                                   :pid => perspective.id  
                      return  
                    end 
                    
                    # Sinon on affiche les composantes   si en mode connecté
                    if !User.current.guest?
                      redirect_to  :controller => "entity",  :action => 'composantes',:id => @entity
                    # Si en mode non connecté en affiche la première perspective
                    else
                      pid=-1
                      if  User.current.profile.perspective!=nil
                        pid=User.current.profile.perspective.id
                      elsif perspective!=nil
                        pid=perspective.id
                      end

                      redirect_to  :controller => "perspective",  :action => 'default',:id => @entity,
                                   :pid => pid
                    end
        
                    #redirect_to  :controller => "perspective",
                    #             :action => 'default',
                    #             :id => @entity ,
                    #             :pid => User.current.profile.perspective.id if User.current.profile.perspective != nil
                  }
    end
  end
  
  # Recherche des composantes dans l'arborescence
  def searchNode(search)
    logger.info("SERACH MODE #{search}")
    term="%"+ search  +"%"
    results=Composante.all(conditions: ["name like ? OR tag like ?",term,term], limit: 50)
  
    root = Composante.find_by_parent_id(-1)
    
    # Tous les serveurs de l'établissement
    serveurs=[Master.serveur.to_json]
    serveurs.concat(Master.allServeursForEntity User.current.current_entity)
    
    tree={}
    
    # On ajoute le parent dans l'arborescence
    arr=[]
    results.each do |composante|
      next if ! composante.isReadable?
        c=composante;
        while c.id!=1
          tree[c.id]=true
          c=c.parent;
        end
        arr<<composante
    end
    
    # Pour l'ensemble des serveurs on construit
    list=[]
    serveurs.each do |serveur|
      uid=serveur[:attr][:serveur_uid]
      id=serveur[:attr][:rawid]
      fullname=serveur[:attr][:fullname]
      #arr.each do |composante|
      #  next if composante.serveur.id!=id
        #list <<  composante.to_json(uid,true)
        list<< Composante.getComposanteFromFullname(fullname).buildTree(tree,uid)
      #end
    end
  
    list={   :attr =>  { :id => "#{root.id}" , :tag => root.tag.to_s,:name => root.name.to_s},
             :data =>  { :title =>   "#{root.name.to_s }"  , :icon =>   root.getImage() }   ,
             :children => list } 
    
    render :json => list.to_json
    
  end
  
  
  def node
    @entity=params[:id]
    cpid=params[:rawcomposanteid]
    hideLeaf=params[:hideLeaf]=="true"
    #logger.info("SERACH MODE [#{cpid}]") 
    
    User.current.current_entity=@entity
    @serveur_uid=params[:serveur_uid]
    
    # SI le paramètre de recherche est positionné, on effectue la recherche
    if params[:search]!=nil && !params[:search].empty? && cpid == "-1"
      searchNode(params[:search])
      return
    end

    if params[:composanteid] != "-1"
      @node = Composante.find_by_id(params[:composanteid])
    else
      @node = Composante.find_by_parent_id(-1)
    end
    render :json => custom_json_for(@node,hideLeaf)
  end
  
  def update
    @entity=params[:id]
    @arrUpdated=[]
    source="Modifié par <user>#{User.current.uid}</user>"
    valeurs=params[:valeurs]
    valeurs.each do |valeur|
        valeur=valeur[1]
        id=valeur[:id]
        v=valeur[:valeur]
        a=id.split(Composante::UID_SEP)
        uid=a[0]
        composante=Composante.find(a[1])
        response=Value.setComposanteValue(uid: uid,
                                 composante: composante,
                                 valeur: v, source: source)
        if response.error?
          val=Value.getValeur(uid,composante)
          @arrUpdated<<{id:id,valeur:val,success:false}
        else
          @arrUpdated<<{id:id,valeur:v,success:true}
        end                         
                                 
    end
    
    respond_to do |format|
      format.js
    end
    
  end
  
  # =================================================================

  # Renvoie l'historique d'une composante au jormat json, pour jqgrid
  def valeurs
    @entity=params[:id]
    composante=Composante.find_by_id(params[:composanteid])
    return if ! isReadable? composante
    
    
    valeurs=ValueHistory.all(conditions: ["uid=? AND composante_id=? AND created_at >= ? AND created_at <= ?",
                             params[:uid],composante.id,@dstart,@dend],:limit => 200,:order => "created_at DESC")
    list=[]
    valeurs.sort{|t1,t2|t1.created_at <=> t2.created_at}.each do |vh|
      a=[vh.created_at.to_f * 1000,vh.etat,vh.source,vh.valeur,vh.message]
      list<<{ :id => @entity, :cell => a}
    end

    respond_to do |format|
      format.json {render :json => { :page => "1", :total => 1, :records => list.size , :rows =>  list}.to_json}
    end

  end
  
  def getValuesForALeaf(uid,composante)
      return nil if ! composante.isLeaf?
      return nil if ! composante.isReadable?
      
      if uid==nil
        cuid=Master.serveurUidsForComposante(composante)
        vuid=Value.getValue(@entity,cuid)
        uid=vuid.toutesLesValeurs().first if vuid!=nil  
      end
      
      valeurs=ValueHistory.all(conditions: ["uid=? AND composante_id=? AND created_at >= ? AND created_at <= ?",
                             uid,composante.id,@dstart,@dend],:limit => 200,:order => "created_at DESC")
      list=[]
      type=composante.categorie
      valeurs.sort{|t1,t2|t1.created_at <=> t2.created_at}.each do |vh|
        dd=vh.created_at.to_f * 1000
        v=vh.valeur
        desc=vh.valeur
        case type
          when Composante::STATUT
            v=composante.id;desc=vh.valeur
          when Composante::UPTIME
            desc="Reboot #{vh.extra[:time]}"  
          when Composante::CAPACITYDISK
            v=vh.extra[:used];desc="#{vh.extra[:used]}/#{vh.extra[:available]}"
        end
          
        valeur=v.to_i
        list<<{ timestamp: dd, valeur: valeur, string: desc}
      end
      list
  end
  
  # valeurs pour le graphique
  def valeursData
    @entity=params[:id]
    composantes=params[:composanteid];
    exclude=params[:exclude];
    uid=params[:uid]
    
    #User.current.showEntity(@entity,params[:composanteid])
    User.current.currentComposante=params[:composanteid];
    
    if !exclude
      exclude=[] 
    else
      exclude=exclude.split("|")
    end
    
    #logger.info("EXCLUDE:#{exclude}")
    
    listeDesComposantes=[]
    if ! composantes.include? "|"
      c=Composante.find_by_id(composantes)
      if c!=nil &&  c.isReadable?
        listeDesComposantes<< c  
      end
    else
      uid=nil
      composantes.split("|").each do |fullname|
        next if fullname.empty?
        c=Composante.getComposanteFromFullname(fullname)
        listeDesComposantes<< c  if c!=nil &&  c.isReadable?
      end 
    end
    
    all=[]
    
   # Pour chaque composante passée en paramètre
   listeDesComposantes.each  do |composante|
      
      if composante.isLeaf?
        next if exclude.include? composante.id.to_s
        values=getValuesForALeaf(uid,composante) 
        next if values!=nil && values.count==0
        ui=composante.graphiqueOptions;ui[:data]=values
        all<< ui if values !=nil
      else
        composante.children.each do |c|
          next if exclude.include? c.id.to_s
          values=getValuesForALeaf(uid,c) 
          next if values!=nil && values.count==0
          ui=c.graphiqueOptions ; ui[:data]=values
          all<< ui if values !=nil
        end    
      end
    end # Fin 
    
    respond_to do |format|
      format.json {render :json => all.to_json}
    end

  end
  
  
  def logs
    
    @entity=params[:id]
    
    # Récupération des composantes passées en parametre pour le filtrage
    composantes=params[:composantes]
    arr=[]
    composantes.split("|").each do |c|
      next if c.empty?
      composante=Composante.getComposanteFromFullname(c)
      next if composante==nil || !composante.isReadable?
      
      arr.concat(composante.getChildrensId())
    end
    
    if arr.empty?
      logs=Log.all(conditions: ["masteruid=? AND created_at >= ? AND created_at <= ?",
                             @entity,@dstart,@dend],:limit => 200,:order => "created_at DESC")
    else
      logs=Log.all(conditions: ["masteruid=? AND created_at >= ? AND created_at <= ? AND composante_id IN (?)",
                             @entity,@dstart,@dend,arr],:limit => 200,:order => "created_at DESC")  
    end
    
    list=[]
    logs.each do |vh|
      next if !vh.composante.isReadable?
      a=[vh.created_at.strftime("%A %e/%m"),vh.created_at.to_f * 1000,vh.source,
          vh.composante.fullname,vh.message,vh.etat,vh.composante.categorie]
      list<<{ :id =>vh.id, :cell => a}
    end

    respond_to do |format|
      format.json {render :json => { :page => "1", :total => 1, :records => list.size , :rows =>  list}.to_json}
    end
     
  end
  
  

  # Affichage des valeurs
  def show
    @entity=params[:id]
    serveur_uid=params[:serveur_uid]
    composante=Composante.find_by_id(params[:composanteid])
     
    User.current.currentComposante=params[:composanteid];
    # User.current.showEntity(@entity,"composantes&cid=#{params[:rawcomposanteid]}")
    #User.current.showEntity(@entity,params[:rawcomposanteid])
    if serveur_uid!=nil
      @parentid="#{serveur_uid}#{Composante::UID_SEP}#{composante.id}"
    else
      @parentid=composante.id
    end
   
    # On récupère les dossiers 
    @dossiers=[]
    composante.children.each do |node|
        next if node.isLeaf?
        @dossiers<<node.to_json(serveur_uid) if node.isReadable?  
    end

    # On récupère les feuilles
    @composantes=[]
    search=params[:search]
    search="" if !search
    serveur_uid=(serveur_uid==nil)?@entity:serveur_uid
    composante.children.each do |node|
        next if node.isFolder?
        l=node.to_json(serveur_uid)
        
        # Composante non asscessible
        if ! node.isReadable?
          l[:attr][:valeur]=Value::FORBIDDEN
          l[:attr][:format]=Value::FORBIDDEN
          l[:attr][:message]="" 
          @composantes<<l 
          next 
        end
        
        # Critère de recherche ?
        if !search.empty? 
            bName=node.name =~ /#{search}/
            bTag=node.tag =~ /#{search}/
            next if !bName && !bTag
        end
        
        
        value= Value.getValue(serveur_uid,node)
        if value != nil && value.valeur != Value::NOTEXIST
          l[:attr][:valeur]=value.valeur
          l[:attr][:format]=value.format(true)
          # Si en Echec on affcihe le message
          if value.etat==Value::KO
            l[:attr][:message]=value.message 
          else
            l[:attr][:message]="" 
          end
        # Pas de valeur mais en écriture et en mode édition, on présente quand même la valeur ""
        elsif  composante.isWritable? 
          next if ! User.current.has(Profile::EDIT_MODE)
          l[:attr][:valeur]=""
          l[:attr][:format]=""
          l[:attr][:message]="" 
        elsif value != nil && value.valeur == Value::NOTEXIST
          next
        else
          next
          l[:attr][:valeur]=Value::NOTEXIST
          l[:attr][:format]=Value::NOTEXIST
          l[:attr][:message]=""
        end

        @composantes<<l 
    end
    
    respond_to do |format|
      format.html { render :layout => false}
    end
    
  end
  # ===================================================================
  
  # Renvoie un json contenant la liste des erreurs pour les serveurs passé en paramètre 
  def errors
    @entity=params[:id]  
    serveurs_tag=params[:tags]
   
    listes_des_erreurs=[]
   
    # Toutes les valeurs en erreurs pour l'entité   
    values=Value.all(conditions: [ "etat = ? AND masteruid= ?",Value::KO,@entity])
    values.each do |value|
      #next if value
      listes_des_erreurs<<{uid:value.uid,
                           message:value.message,
                           format:value.format,
                           serveur_name:value.composante.serveur.name,
                           composante_name:value.composante.name}      
    end
      
    respond_to do |format|
      format.json {render :json => listes_des_erreurs.to_json}
    end
    
  end
  
  def sideheader
    @entity=params[:id]
    respond_to do |format| 
      format.html { render :partial => "sidebar" ,:locals => {:hideperspective=>false} }
    end  
  end
  
  def composantes_side
    @entity=params[:id]
    logger.info("TOPOEN: #{@nodesToOpen} / #{User.current.getEntityAction(@entity)} ")
    respond_to do |format| 
      format.html { render :partial => "entity/composantes" ,:locals => {:nodesToOpen=>@nodesToOpen}}
    end   
  end

  # Affiche les composantes  Arbre de gauche + Liste de droite
  # La liste de droite est rendu par l'action show
  def composantes
    @entity=params[:id]
    @current_rubrique="composantes"
    User.current.showEntity(@entity,"composantes")
    respond_to do |format| 
      format.html { render :layout => nil if params[:nolayout] }
    end
  end


  def historiques
    @entity=params[:id]
    @current_rubrique="historiques"
    #User.current.showEntity(@entity,"historiques")
    respond_to do |format|
      format.html  { render :layout => nil if params[:nolayout] }
    end
  end
  
  
  def journal
    @entity=params[:id]
    @current_rubrique="journal"
    #User.current.showEntity(@entity,"journal")
    respond_to do |format|
      format.html { render :layout => nil if params[:nolayout] }
    end
  end
  
  
  private
  def custom_json_for(root,hideLeaf)
    
    return [] if root==nil

  #  logger.info("HIDELEAF #{hideLeaf}")
    
    if root.parent_id == -1
      # Master par défaut
      list=[Master.serveur.to_json]
      #Liste des serveur pour l'entity
      serveurs=Master.allServeursForEntity(User.current.current_entity,hideLeaf)
      
      list.append serveurs
      
      #logger.info("==================================================")
      #logger.info(serveurs)
      #logger.info("==================================================")
      
      #On crée une liste avec tout ça
      list={   :attr =>  { :id => "#{root.id}" , :tag => root.tag.to_s,:name => root.name.to_s},
             :data =>  { :title =>   "#{root.name.to_s }"  , :icon =>   root.getImage() }   ,
             :children => list }
              
    else
      
      list=[]
      root.children.each do |node|
        next if node.isLeaf?  && hideLeaf
        list<<node.to_json(@serveur_uid,false,hideLeaf) if node.isReadable?
      end
                    
    end
    
    list.to_json
  end




end