# -*- coding: utf-8 -*-
class ImportationController < ApplicationController

  IMPORT_PATH="data/importations"
  include Utils


  def index
    set_menu menu: "gestion", rubrique: "importations"
    respond_to do |format|
      format.html # index.html.erb
      format.js
    end
  end


  def import

    # Récupération des composantes
    composantes=[]
    ckey=nil # La composante servant d'identifiant, on prend la première trouvée
    index_ckey=-1  # Indice
    a=params[:columns].split(",")
    (0..a.size-1).each do |i|
      c=Composante.find_by_fullname(a[i])
      composantes<<c
      ckey=c if c.flaguid? and ckey==nil
      index_ckey=i if c.flaguid? and index_ckey==-1
    end

    if ckey!=nil
      
      @response=Utils::Response.new
      threads = []
      threads << Thread.new {
      #process = fork do
        # Parse le fichier
        File.open(File.join(IMPORT_PATH, params[:importid]), "r") do |aFile|
  
          aFile.readline if  params[:header]
          ligne=1
          # Chaque ligne
          aFile.each_line do |line|
            line.strip!
            ligne=ligne+1
            values=line.split(params[:sep])
            
            (0..values.size-1).each do |i|
              #next if index_ckey==i
              @response=Value.setValue(ckey: ckey, ckeyvalue: values[index_ckey], composante: composantes[i], value: values[i])
              if  @response.error?
                m=@response.message
                @response.message="Ligne #{ligne} [#{m}] (#{line})"
                flash.now[:error]="Erreur lors de l'importation"
                break
              end
            end # End each
            
            break if  @response.error?
            
          end
        end
        #Process.kill("HUP") 
      }  
      #end 
      #Process.detach(process) 
      
    else
      flash.now[:error]="Au moins une composante clef doit être renseignée"
    end

    
    #threads.each do |t|
    #  t.join
    #end

    respond_to do |format|
      format.js
    end


  end

  def uploadfile

    require 'fileutils'
    tmp = params[:uploadfile][:fichier].tempfile
    @sep = params[:uploadfile][:separateur]
    @hasHeader = params[:uploadfile][:header]
    #logger.info(tmp.methods)

    @columns=tmp.first.split(@sep)
    if ! @hasHeader

    end

    @importid=Time.new.to_time.to_i().to_s()+"_"+params[:uploadfile][:fichier].original_filename


    file = File.join(IMPORT_PATH, @importid)
    FileUtils.cp tmp.path, file
    respond_to do |format|
      #format.html
      format.js
    end


  end
end