# -*- coding: utf-8 -*-
class MainController < ApplicationController

  
  before_filter :unset_current_entity 

  include Entities

  def buildNavigation
    super
    @vues=Vue.filtres
  end
  
 # ================== GESTION DE LA GALLERY DE MARKERS =============
  def icone
    @ico = Icone.find(params[:id])
    send_data @ico.image, :type => 'image/png',:disposition => 'inline'
  end

  # Tous les markers d'un dossier
  def markers_gallery
    @filtre=Filtre.find(params[:current])
    @files = Icone.getFiles params[:dossier]
    respond_to do |format|
      # HERE
      #format.json { render json: list.to_json }
      format.js
    end
  end
  
  # Tous les dossiers d'un dossier
  def markers_folders

    folders = Icone.getFolders params[:dossier]
    list = folders.map do |folder|
       { :data => { :title =>   File.basename(folder.gsub("-","/"))  },
         :icon => "/assets/picto/folder.png",
         :state =>  (Icone.hasFolders? folder)?"closed":"" ,
         :attr =>  {:id => folder}
       }
    end

    if params[:dossier]==nil || params[:dossier].empty?
      list= { :data => { :title =>   "Pictogrammes"  },
              :children=> list ,   :state =>  "open",
              :icon => "/assets/picto/folder.png",
              :attr =>  {:id => ""}
      }
    end
    
    respond_to do |format|
      format.json { render json: list.to_json }
    end
    
  end
  
  # ================================================================

  # ================= GESTION DES DROITS ==========================
  def rights
    @objet= Objet.find(params[:id])
    list = @objet.rights.map do |right|
      right.to_json
    end
    list = { :page => "1", :total => 1, :records => @objet.rights.count , :rows => list }
    respond_to do |format|
      format.json { render json: list.to_json }
    end

  end

  def right_add
    @objet= Objet.find(params[:id])
    right=Right.new
    right.user=Group.nobody
    right.droit=Permission::READ
    @objet.rights<<right
    @objet.save
    respond_to do |format|
      format.js { render js: "$('#listrights' ).jqGrid().trigger('reloadGrid');"}
    end

  end

  def right_save
      objet=Objet.find(params[:oid])
      right=Right.find(params[:id])
      user=User.find_by_uid(params[:uid])
      #if  objet.rights.include? right && user!=nil
        right.droit=params[:droits]
        right.user=user
      #end
      right.save
      respond_to do |format|
        format.json {render :json => { }.to_json }
      end
  end


  def rights_delete
    rights = params[:to_delete].map   { |t| Right.find_by_id(t) }
    rights.delete(nil)
    rights.each { |t| t.destroy }
    respond_to do |format|
      format.js { render js: "$('#listrights' ).jqGrid().trigger('reloadGrid');"}
    end
  end
  
  def objet
    objet=Objet.find(params[:id])  
    objet.nom=params[:nom]
    type=objet.categorie
    logger.info("TYPE:#{type}")
    objet.save
    respond_to do |format|
      format.js { 
        render :js => '$( "#listvues" ).trigger("reloadGrid");'    if type==  Objet::FILTRE_VUE ||  type==  Objet::VUE
        render :js => '$( "#listfiltres" ).trigger("reloadGrid");' if type==  Objet::FILTRE  
        
      }
    end
  end
  
  # ===========================================================

  # return la description d'un objet
  def description
    o=Objet.find(params[:id])
    respond_to do |format|
      format.json { render json: {description:o.description}.to_json }
    end
  end

  def filtres
    list = @filtres.map do |filtre|
      filtre.json
    end
    list = { :page => "1", :total => 1, :records => @filtres.count , :rows => list }

    respond_to do |format|
      format.json { render json: list.to_json }
    end
  end

  def vues
    @vues=Vue.filtres
    #logger.info(@vues)
    list = @vues.map do |filtre|
      filtre.json
    end
    list = { :page => "1", :total => 1, :records => @vues.count , :rows => list }

    respond_to do |format|
      format.json { render json: list.to_json }
    end
  end
  
  def perspectives
    @perspectives=Perspective.currents
    list = @perspectives.map do |p|
      p.json
    end
    list = { :page => "1", :total => 1, :records => @perspectives.count , :rows => list }

    respond_to do |format|
      format.json { render json: list.to_json }
    end
  end 
  
  def scripts
    @scripts=Script.currents
    list = @scripts.map do |p|
      p.json
    end
    list = { :page => "1", :total => 1, :records => @scripts.count , :rows => list }

    respond_to do |format|
      format.json { render json: list.to_json }
    end  
  end 

  def vues_definition


    list = Vue.currents.map do |vue|
      { :id=>vue.id, :actif => vue.actif? , :nom=> ApplicationController.helpers.format_objet(vue) , :editable=>vue.writable?(false) }
    end


    respond_to do |format|
      format.json { render json: list.to_json }
    end
  end


  def objet_share
    @objet=Objet.find(params[:id])
    respond_to do |format|
      format.js  {
        render partial: "objet_share"
      }
    end
  end

  def filter_edit
    @objet=Objet.find(params[:id])

    # Est-ce un filtre ?
    if @objet.filtre?
      @filtre=Filtre.find(params[:id])
      @files = Icone.getFiles ""
    end

    # Une perspective ? => Cela permet de mettre par défaut la perspective
    if  @objet.perspective?
      perspective=Perspective.find(params[:id])
      User.current.profile.affecterUneperspectiveParDefaut perspective
      User.current.profile.save
    end


    respond_to do |format|
      format.js  {
        render partial: "filter_edit" if @objet.filtre?
        render partial: "perspective/perspectives"  if @objet.perspective?
      }
    end
  end

  def filter_activate
    @filtre=Filtre.find_by_id(params[:id])
    if @filtre==nil
      nofilter
      return
    end
    
    exclusif=params[:exclusif]
    
    # En mode exlusif ? on supprime le filtrage existant
    if exclusif=="true"
      vues=User.current.profile.getFiltresVue
      User.current.profile.filtres.clear #=User.current.profile.filtres.delete_if {|x| !x.filtreVue? }
      User.current.profile.filtres.concat(vues)
      User.current.profile.set(Profile::FILTRE_EXC,params[:id])
    else
      User.current.profile.set(Profile::FILTRE_EXC,-1)
    end
    
    if params[:actif]=="true"
      User.current.profile.filtres<<@filtre
    else
      User.current.profile.filtres.delete @filtre
    end
    User.current.profile.save
    respond_to do |format|
      format.js  { render :js => "DrawMap(true);"}
    end
  end
  
  def nofilter
    logger.info("#{User.current.profile.id} #{User.current.profile.filtres}")
    vues=User.current.profile.getFiltresVue
    User.current.profile.filtres.clear #=User.current.profile.filtres.delete_if {|x| !x.filtreVue? } 
    User.current.profile.filtres.concat(vues)
    User.current.profile.save
    #current=Filtre.find_by_id(User.current.profile.get(Profile::FILTRE_EXC)) 
    #User.current.profile.filtres.delete current if current != nil
    User.current.profile.set(Profile::FILTRE_EXC,-1)
    User.current.profile.save
    logger.info("#{User.current.profile.id}  #{User.current.profile.filtres}")
    respond_to do |format|
      format.js  { render :js => "DrawMap(true);"}
    end  
  end
  
  

  def filter_save

    @filtre=Filtre.find(params[:id])
    @filtre.commun=params
    @filtre.groupe=params[:groupe] if !@filtre.filtreVue?
    @filtre.expression=params[:expression]
    @filtre.pictogramme=params[:pictogramme]
    if Value.to_bool(params[:exclusif])
      logger.info("°°°°EXCLUSIF°°°°")
      @filtre.mode= Filtre::EXCLUSIF
    else
      @filtre.mode= Filtre::NORMAL
    end 
    @filtre.save

    respond_to do |format|
      format.js  {
          #render :partial => "filtres"   if @filtre.categorie==Objet::FILTRE
          #render :partial => "vues"   if @filtre.categorie==Objet::FILTRE_VUE
          render :js => '$( "#listvues" ).trigger("reloadGrid");' if  @filtre.categorie==  Objet::FILTRE_VUE
          render :js => '$( "#listfiltres" ).trigger("reloadGrid");' if  @filtre.categorie==  Objet::FILTRE
      }
    end
  end

  def filter_add

    @filtre=Filtre.create(nom:"Nouveau")
    respond_to do |format|
      #format.js  {render :partial => "filtres"}
      format.js  { render :js => '$( "#listfiltres" ).trigger("reloadGrid");'}
      
    end

  end

  def vue_add
    @vue=Vue.new
    @vue.default
    @vue.save
    respond_to do |format|
      format.js  { render :js => '$( "#listvues" ).trigger("reloadGrid");'}
    end
  end
  
  def vue_change_name
    vue=Vue.find(params[:id])
    nom=params[:name].split("<span")[0]  
    return if ! writable? vue
    vue.nom=nom
    return if ! saveObject vue
    
    respond_to do |format|
      flash.now[:notice]="Le nom de la vue a été changé"
      format.js  { render :partial => "shared/flash" ,  :locals => { :flash => flash }}
    end
    
  end


  def vue_add_filter
    @vue=Vue.find(params[:id])
    f=Filtre.create
    f.nom="Nouveau"
    f.groupe=@vue.id
    f.save
    @vue.filtres<<f
    @vue.save
    respond_to do |format|
      #format.js  {render :partial => "vues"}
      format.js  { render :js => '$( "#listvues" ).trigger("reloadGrid");'}
    end
  end

  def vue_toggle

    vue= Vue.find(params[:id])
    vues=User.current.profile.vues_active
    if vues==nil
      vues=[]
    end
    if vues.include?  vue.id
      vues.delete vue.id
    else
      vues << vue.id
    end
    User.current.profile.update_attribute(:vues_active,vues)

    respond_to do |format|
      format.json  { render :json => {actif:vue.actif?,filtres:vue.filtres.map { |x| x.id} } }
    end
  end

  def vue_reorder

    current=params[:current]
    replace=params[:replace]

    order=User.current.profile.vues_order
   # logger.info("BEFORE ====#{order}")

    c=order.index(current.to_i)
    r=order.index(replace.to_i)
    if c!=nil && r!=nil
      order[c]=replace
      order[r]=current
    end
    User.current.profile.update_attribute(:vues_order,order)
   # logger.info("AFTER ====#{order}")

    respond_to do |format|
      format.js  { render :js => ""}
    end
  end

  def vue_reorderfilters
    ids=params[:ids]
    fcurrent=Filtre.find_by_id(params[:id])
    vue=Vue.find(fcurrent.groupe)
    if ! vue.writable?(false)
      flash.now[:error]="Vous n'avez pas les droits pour modifier la position du filtre"
      flasher
      return
    end


    i=0
    ids.each do |id|
      f=Filtre.find_by_id(id)
      next if f==nil
      f.position=i
      i=i.next
      f.save
    end

    r=""
    r="DrawMap(true);" if fcurrent.selected?

    respond_to do |format|
      format.js  { render :js => r}
    end

  end

  # DELETE /main/filters_delete
  def filters_delete
    objets = params[:to_delete].map   { |t| Objet.find_by_id(t) }
    objets.delete(nil)
    type=objets.first.categorie
    objets.each { |t| t.destroy }
    respond_to do |format|
      format.js {
        flash.now[:notice]="supprimées"
        render :js => '$( "#listvues" ).trigger("reloadGrid");'    if type==  Objet::FILTRE_VUE
        render :js => '$( "#listfiltres" ).trigger("reloadGrid");' if type==  Objet::FILTRE
        render :partial => "perspective/perspectives"              if type==  Objet::PERSPECTIVE
      }
    end
  end

  def vue_delete
    @vue=Vue.find(params[:to_delete])
    @vue.destroy
    respond_to do |format|
      format.js {
        flash.now[:notice]="Vue supprimée"
        #render :partial => "vues"
        render :js => '$( "#listvues" ).trigger("reloadGrid");'
      }
    end
  end



  def accueil

    @currentPerspectiveContexteId=User.current.profile.currentPerspectiveContexte
    @perspectivesContextuelles=Perspective.currents
    respond_to do |format|
      format.html { render :layout => nil if params[:nolayout] }
    end

  end
  
  def sidebar
    unset_menu
    @currentPerspectiveContexteId=User.current.profile.currentPerspectiveContexte
    @perspectivesContextuelles=Perspective.currents
    @rapports=Rapport.currents
    respond_to do |format| 
      format.html { render :partial => "sidebar" , :layout => nil }
    end  
  end
  
  def entities
    
    list={ type: "FeatureCollection",
           features: Entities.getMarkers(logger) }
   
   respond_to do |format|
      format.json { render json: list.to_json } 
    end
    
  end

end