# -*- coding: utf-8 -*-
class PerspectiveController < ApplicationController
 
  include Rapports

  before_filter :unset_menu 

  def add
    @perspective=Perspective.new
    @perspective.save
    respond_to do |format|
      format.js  {render :partial => "perspectives"}
    end  
  end
  
  def get 
     @perspective=Perspective.find(params[:id])
     respond_to do |format|
      format.json {render :json => {data: @perspective.data , contexte: @perspective.contexte}.to_json}
    end  
  end
  
  def default
    @entity=params[:id]
    nolayout=params[:nolayout]
    @perspective=Perspective.find_by_id(params[:pid])
    if @perspective==nil
      redirect_to :root
      return
    end

    return if ! readable? @perspective
    @current_rubrique="perspectives"
    @editMode=(params[:edit]=="true") && @perspective.writable?
    User.current.showEntity(@entity,"perspective&pid=#{@perspective.id}")
    respond_to do |format|
      if nolayout
        format.html { render layout: "empty"} 
      else  
        format.html 
      end
      
      format.js 
    end
  end

  def show
    @entity=params[:id]
    @perspective=Perspective.find(params[:pid])
    @current_rubrique="perspectives"
    User.current.showEntity(@entity,"perspective&pid=#{@perspective.id}")
    respond_to do |format|
      format.html { render :layout => false}
      format.js
    end
  end
  
  def export
    @perspective=Perspective.find(params[:pid])
    @perspective.export(self) 
    
      
  end

  def evaluer
    @entity=params[:entity]
    aformater=params[:aformater]
    values=[]
    if aformater
      aformater.each do |format|
        value=Rapports::RapportColumn.formater(@entity,format,false)
        #logger.info("Perspective.evaluer:FORMAT:#{format} entity:#{@entity} => #{value}")
        values<<value
      end
    end
    
    render :text => values.to_json
  end


  def save
    @perspective=Perspective.find(params[:id])
    @perspective.data=params[:portlets]
    @perspective.nom=params[:nom]
    @perspective.contexte=params[:contexte]
    @perspective.description=params[:description]
    @perspective.save
    respond_to do |format|
      format.js  {render :partial => "perspectives"}
    end
  end
  
  
end