# -*- coding: utf-8 -*-
class RapportsController < ApplicationController
  
  before_filter :unset_current_entity 

  include Rapports
  include Utils
  include Entities
  

  
  def mesrapports
    @rapports=Rapport.currents
    @randomid = rand(36**16).to_s(36)
  end

  def check_writable
    if ! @rapport.writable?
      flash.now[:error]="Vous ne disposez pas des autorisations nécessaires"
    end
    @rapport.writable?
  end

  def index
    set_menu menu: "rapports", rubrique: ""
    respond_to do |format|
      format.html {
        if params[:nolayout]
          render(template: "rapports/manage", :layout => nil) 
        else
          render template: "rapports/manage"
        end
       }
      format.js
    end
  end

  def manage
    set_menu menu: "rapports", rubrique: "manage"
    respond_to do |format|
      format.html
    end
  end

  def create
    set_menu menu: "rapports", rubrique: "create"
    @rapport=Rapport.new
    @rapport.id=-1
    respond_to do |format|
      format.html # create.html.erb
      format.js
    end
  end
  
  def sidebar
    @entity=params[:id]
    respond_to do |format| 
      format.html { render :partial => "sidebar" }
    end  
  end
  
  def outils
    @rapport=Rapport.find(params[:id])
    @cache=Value.to_bool(params[:cache])
    respond_to do |format| 
      format.html { render :layout => nil }
    end  
  end

  def show
    set_menu menu: "rapports", rubrique: ""
    @rapport=Rapport.find(params[:id])
    respond_to do |format|
      format.html  { render :layout => nil if params[:nolayout] }
    end
  end
  
  def rendermesrapports
    
    respond_to do |format|
      format.html  { render :partial => "mesrapports" }
    end
  end
  
  
  def export
    
  end
  
  
  def buildRapport
    groupeby=@rapport.groupeby
    order=params[:sidx].to_i
    sord=params[:sord]

    if params[:groupeby]!=nil && params[:groupeby] != "undefined" && !params[:groupeby].empty?
      groupeby=params[:groupeby].to_i
    end
    
    if params[:filtreid]!=nil && params[:filtreid] != "-1" && !params[:filtreid].empty?
      filtre=Filtre.find_by_id(params[:filtreid])
    else
      filtre=@rapport.filtre 
    end
    
    if  params[:filtreid]!=nil && params[:filtreid] == "-1" && params[:groupeby] != "undefined"
      filtre=nil
    end
    
    if params[:groupeby]!=nil && params[:groupeby].empty?
      groupeby=-1
    end
    

    if @rapport.writable?
      @rapport.filtre=filtre
      @rapport.groupeby=groupeby.to_s()
       @rapport.save    
    end
    
    # == Construction de la liste de données
    list=[];
    # Récupère toutes les entitées
    entities=Entities.getCurrents()
    entities.each do |entity|
      next if filtre!=nil && ! filtre.evaluer(entity)    # Si ne match pas le filtre actuel, on passe au suivant
      a=[]
      @rapport.columns.each do |column|
        v=column.formater(entity)
        v="" if v=='""'
        a<<v
      end
      list<<{ :id => entity, :cell => a}

    end

    if groupeby != -1
      order=params[:sidx].split(",")[1].to_i
      list=list.sort_by {|a| [a[:cell][groupeby], a[:cell][order]] }
      if sord=="desc"
      list=list.reverse
      end
    else
      if sord=="desc"
        list.sort! { |b, a|  a[:cell][order] <=> b[:cell][order]}
      else
        list.sort! { |a, b|  a[:cell][order] <=> b[:cell][order]}
      end
    end
    list
  end
  
  def data
     
    @rapport=Rapport.find(params[:id])
    list=buildRapport
     
     
     
    respond_to do |format|
      format.json {
        json={ :page => "1", :total => 1, :records => list.size , :rows =>  list}.to_json
        #User.current.zephir_password=
        #User.current.save
        render :json =>  json
       }
       
       format.csv {
          cols=[]
          @rapport.columns.each do |column|
            cols<<column.nom
          end
          separateur=";"
          separateur=params[:separateur] if params[:separateur]!=nil
          
          require 'csv'
          csv_string = CSV.generate(:col_sep => separateur) do |csv|
            csv << cols
            list.each do |entry|               
              csv << entry[:cell]
            end 
          end
          filename = "#{@rapport.nom}-#{Time.now.to_date.to_s}.csv" 
          send_data(csv_string, :type => 'text/csv; charset=utf-8; header=present', :filename => filename) 
       }
       
    end  
  end
  
  def maj
    @response=Utils::Response.new
    @response.error "Erreur lors de la mise à jour"
    @rapport=Rapport.find(params[:id])
    source="Modifié par #{User.current.uid} depuis rapport '#{@rapport.nom}'"
    valeurs=params[:valeurs]
    valeurs.each do |valeur|
        valeur=valeur[1]
        #logger.info(valeur.to_s())
        column=@rapport.columns[valeur["column"].to_i]
        @response=Value.setComposanteValue(uid: valeur["uid"],composante: column.composante,valeur: valeur["value"],source: source)
        break if @response.error?
    end
    
    respond_to do |format|
      format.html {
        flash.now[:error]=@response.message if @response.error?
        render :js => "window.location = '/rapports/#{@rapport.id}'"
      }
    end
    
    
  end

  def columns
    @rapport=Rapport.find(params[:id])
    list = @rapport.columns.map do |column|
      column.id = randomId if column.id==nil
      { :id => column.id, :cell => [ '',column.nom, column.format] }
    end
    render :json => {:page => "1", :total => 1, :records => @rapport.columns.size , :rows =>  list}.to_json
  end

  def edit
    set_menu menu: "rapports", rubrique: ""
    @rapport=Rapport.find(params[:id])
    respond_to do |format|
      format.html {
        render template: "rapports/create", :layout => nil if check_writable
      }
    end
  end

  def copy
    r=Rapport.find(params[:id])
    @rapport=r.dup
    @rapport.nom<< " (copie)"
    @rapport.save
    respond_to do |format|
      format.html {
        render template: "rapports/show", :layout => nil if check_writable
      }
    end
    
  end

  def delete
    @rapport=Rapport.find(params[:id])
    @rapport.destroy
    respond_to do |format|
      format.html {
        redirect_to :action => "manage"
      }
      
      format.js {
        render :js => "Rapports();refreshMesRapports();"
      }
    end
    
  end
  
  
  def new
    
    columns=[]
    if (params[:id]==nil || params[:id]=="-1")
      @rapport=Rapport.new
      @rapport.nom="Nouveau rapport"
      @rapport.description="Description du rapport"
      @rapport.addColumn(Master.composanteKey.tag)
      @rapport.addColumn("libelle")
     
    else
      @rapport=Rapport.find(params[:id])
    end
    
    @rapport.nom=params[:nom] if params[:nom]
    @rapport.description=params[:description] if params[:description]
    
    count=params[:count].to_i
    
    (0..count-1).each do |i|
      c=RapportColumn.new
      c.nom=params[:columns][i.to_s][:nom]
      c.format=params[:columns][i.to_s][:format]
      c.id=params[:columns][i.to_s][:id]
      columns<<c 
    end
    @rapport.columns=columns
    @rapport.save
    
    respond_to do |format|
      format.html {
        flash.now[:notice]="Rapport créé"
        render :js => "ShowRapport('#{@rapport.id}')"
      }
      
      format.js {
        render :js => "refreshMesRapports();ShowRapport('#{@rapport.id}');"
      }
    end
    
  end

  def addcolumn
    @rapport=Rapport.find(params[:id])
    nom=params[:nom]
    format=params[:detail]
    id = randomId
    columns=@rapport.columns
    c=RapportColumn.new
    c.nom=nom
    c.format=format
    c.id = id
    columns<<c
    @rapport.columns=columns
    @rapport.save
    respond_to do |format|
      format.html
      format.js {
        render :partial => "rapport"
      }
    end
  end






end