# -*- coding: utf-8 -*-
class SessionController < ApplicationController

  skip_filter :checkCasClient, :getuser, :setConnectedUser,:buildNavigation,:buildRubriques ,:only=> :logout

  def login

    # La session existe déja, avec une session invité
    # On détruit l'utilisateur invité
    if session[:userid]!=nil 
      u=User.find( session[:userid])
      if u.guest?
        u.destroy
        reset_session
      end

    end

    # Indique que l'on souhaite une authentification SSO/CAS
    if params[:cas]=="true"
      session[:cas]=true
      redirect_to  :root  # Le plugin SSO , se chargera de recupérer l'utilisateur
      return
    end
    
    @nocas=params[:cas]=="false"

    # Si une session existe on renvoie vers la racine
    if session[:userid]
      redirect_to  :root
      return
    end

    # Redirection vers le formulaire d'authentification
    respond_to do |format|
      format.html { render :layout => false } # login.html
    end

  end

  def connect

    # Recherche de l'utilisateur dans la base
    u=User.first(conditions: [ "uid = ? AND password = ?", params[:login], params[:password]])

    # Pas trouvé => Echec
    if u==nil
      flash[:error]="Echec de l'authentification"
      flasher
      return
    end
    
    # On enlève les groupes dynamiques
    u.groups=u.groups.delete_if  {|g| g.dynamic }
    u.save
    
    # OK, on initialise la session
    InitialiserLaSessionPour(u)
    
    # Le navigateur redirigera vers la racine
    respond_to do |format|
      format.html {
        render text: root_url
      }
    end
  end
  

  def remove_entity
    User.current.remove_entity(params[:entity]) 
    User.current.save
    respond_to do |format|
      format.js { render :js => ""}
    end
  end

  
  def changeuser
    u = User.find(params[:id])
    if @connectedUser.admin? || @connectedUser.manager?
      session[:userid]=u.id
      User.current=u
    end
    redirect_to  :root
      
  end

  def self.current_user_id
   User.current.id if User.current != nil
    -1
  end

  def self.current_user
    User.current
  end

  def logout
    
    if session[:cas]
      reset_session
      CASClient::Frameworks::Rails::Filter.logout(self,url_for( controller: "main", action: "accueil"))
      return true
    end
    
    reset_session
    redirect_to  :root
  end

end