# -*- coding: utf-8 -*-
class Appconfig < ActiveRecord::Base

  attr_accessible :key , :value , :categorie, :desc , :groupe, :ssgroupe

  # Généralités
  GEN_ALLOW_GUEST={key: :GEN_ALLOW_GUEST, categorie: "booleen",ssgroupe:"Mode invité",  value:"false",desc: "Autorisé l'accès en mode 'Invité" }
  GEN_GUEST_FILTER={key: :GEN_GUEST_FILTER,categorie: "filtre" , ssgroupe:"Mode invité", value:"",desc: "Filtre par défaut pour le mode Invité" }


  # Zephir
  ZEPHIR={key: :ZEPHIR, categorie: "booleen", value: "true", desc: "Utiliser zephir pour la récupération des droits/groupes"}
  ZEPHIR_HOST={key: :ZEPHIR_HOST, desc: "Host zephir (Ex: zephir.ac-reunion.fr [ sans le https ]"}
  ZEPHIR_API_PORT={key: :ZEPHIR_API_PORT, desc: "Port d'accès à l'API", value: "7080" }
  ZEPHIR_LOGIN={key: :ZEPHIR_LOGIN, desc: "Login d'accès en lecture à zephir" }
  ZEPHIR_PASSWORD={key: :ZEPHIR_PASSWORD, desc: "Mot de passe associé au compte en lecture" }

  # Authentification CAS
  CAS={key: :CAS, categorie: "booleen", value: "false", desc: "Utiliser une authentification CAS"}
  CAS_URL={key: :CAS_URL, desc: "URL du serveur CAS (Ex: https://cas.serveur.com:port)"}
  CAS_ATTRIBUTE_GROUPE={key: :CAS_ATTRIBUTE_GROUPE,
                        desc: "Attributs CAS permettant de désigner les groupes (séparés par une , )"}

  # CAS => On The Fly
  CAS_USER_ONTHEFLY={key: :CAS_USER_ONTHEFLY, categorie: "booleen",ssgroupe:"Création à la voléé", value: "false",
                     desc: "Créer des utilisateurs à la volée"}

  CAS_ATTRIBUTE_NAME={key: :CAS_ATTRIBUTE_NAME,ssgroupe:"Création à la voléé",
                                desc: "Attribut CAS décrivant le <b>nom</b> de l'utilisateur"}
  CAS_ATTRIBUTE_FIRSTNAME={key: :CAS_ATTRIBUTE_FIRSTNAME,ssgroupe:"Création à la voléé",
                      desc: "Attribut CAS décrivant le <b>prénom</b> de l'utilisateur"}
  CAS_ATTRIBUTE_MAIL={key: :CAS_ATTRIBUTE_MAIL,ssgroupe:"Création à la voléé",
                      desc: "Attribut CAS décrivant le <b>mail</b> de l'utilisateur"}
  CAS_ATTRIBUTE_MANDATORY_NAME={key: :CAS_ATTRIBUTE_MANDATORY_NAME,ssgroupe:"Création à la voléé",
                        desc: "Attribut CAS obligatoire pour la création d'un compte"}
  CAS_ATTRIBUTE_MANDATORY_VALUE={key: :CAS_ATTRIBUTE_MANDATORY_VALUE, ssgroupe:"Création à la voléé",
                        desc: "Valeur de l'attribut CAS obligatoire pour la création d'un compte"}

  # Expert
  #EXPERT_MAX_THREAD={key: :EXPERT_MAX_THREAD , ssgroupe:"Tâche", value: "10",
  #                   desc: "Nombre maximal de thread pour une tâche"}

  GROUPES=[
          {
              name: "Générale",
              params: [GEN_ALLOW_GUEST,GEN_GUEST_FILTER]
          }  ,


          { name: "Authentification CAS",
            params: [CAS,CAS_URL,CAS_ATTRIBUTE_GROUPE,
                     CAS_USER_ONTHEFLY, CAS_ATTRIBUTE_NAME,CAS_ATTRIBUTE_FIRSTNAME,CAS_ATTRIBUTE_MAIL,
                     CAS_ATTRIBUTE_MANDATORY_NAME,CAS_ATTRIBUTE_MANDATORY_VALUE]
          } , 
          
          { name: "Zephir",
            params: [ZEPHIR,ZEPHIR_HOST,ZEPHIR_API_PORT,ZEPHIR_LOGIN,ZEPHIR_PASSWORD]
          } ,
          
          {
              name: "Avancé",
              params: []
          }  ,
          

  ]


  before_save  do
    User.current.admin?
  end


  def self.createMethods

    Appconfig.all(conditions: ["id != 0"]).each do |conf|
      self.class.send(:define_method, conf.key) do
        Appconfig.get(conf.key.to_sym)
      end

      self.class.send(:define_method, "#{conf.key}=") do  |value|
        Appconfig.set(conf.key.to_sym,value)
      end

    end

  end

  def self.init
    GROUPES.each do |g|
      #puts g
      Appconfig.creategroupe(g)
    end
  end

  def self.creategroupe(g)
      return if !User.current.admin?
      g[:params].each do |p|
        #puts "=>#{p}"
        conf=Appconfig.new(p)
        conf.groupe=g[:name]
        conf.save
      end
  end

  def self.get(key)
    conf=Appconfig.find_by_key(key)
    return nil if conf==nil
    v= conf.value
    if conf.booleen?
      v=Value.to_bool(v)
    end
    v
  end

  def self.set(key,value)
    conf=Appconfig.find_by_key(key)
    return if conf==nil
    conf.update_attributes({:value => value})
  end

  def booleen?
    categorie=="booleen"
  end


end
