class Filtre  < Objet
  
  include Rapports

  attr_accessible :groupe , :expression , :mode , :position
  
  NORMAL=0
  EXCLUSIF=1

  has_many :profiles
  belongs_to :evaluation

  has_and_belongs_to_many :composantes , :join_table => :filtres_composantes
  
  def initialize(*params)
      super(*params)
      self.categorie=FILTRE
      self.data=FiltreData.new if self.data==nil 
      self.mode=NORMAL
      self.evaluation=Evaluation.create
      self.position=0
  end

  after_find do
    @needToBeCompiled=false
  end
  

  

  before_save do
   # logger.info("===> Filtre before_save => #{self.expression} #{@needToBeCompiled}")
    Icone.destroy_all("uid like '%|#{id}|%'")
    if @needToBeCompiled
      logger.info("===> Filtre Data changed => Compute Filter")
      clear
      Entities.computeFilter(self)
      self.composantes=self.data.composantes
      @needToBeCompiled=false
    end

    true
  end

  # === CURRENTS
  def self.currents
    Objet.filtrer(Filtre.all(:conditions => ["categorie = ?",FILTRE],:order=> :nom))
  end
  
  def self.currentsFiltreVue
    Filtre.all(:conditions => ["categorie = ?",FILTRE_VUE],:order=> :nom)
  end
  
  def self.getAll
    Filtre.all(:conditions => ["categorie = ? or categorie = ?",FILTRE,FILTRE_VUE])
  end

  def filtreVue?
    self.categorie==FILTRE_VUE
  end
  
  def exclusif?
    mode==EXCLUSIF
  end
  
  def pique?
    expression==""
  end

  def evaluer(uid,bForce=false,bSave=true)
    return evaluation.valeur(uid) if !bForce && evaluation.contains?(uid)
    if bForce && bSave
      evaluation.reload 
      evaluation.remove(uid)  
    end
    b=data.evaluer(uid)
    if ! (!!b == b)
      #puts("EVAL:Evaluation de '#{self.data.expression}' pour #{uid} not bool (#{b})"  )
      return
    end 
    evaluation.maj(uid,b)
    evaluation.save if bForce  && bSave
    b
  end

  def clear
    evaluation.clear
    evaluation.save
  end
    
  def expression=(c)
      self.data=FiltreData.new if self.data==nil
      return if self.data.expression==c
      self.data.expression=c
      @needToBeCompiled=true
  end
  
  def expression
      self.data.expression
  end
  
  def groupe=(c)
    self.data=FiltreData.new if self.data==nil 
    self.data.groupe=c
  end

  def groupe
    self.data.groupe
  end

  def pictogramme=(c)
    self.data.pictogramme=c
  end

  def pictogramme
    self.data.pictogramme
  end

   def uiDisplay
    c=""
    #c="<small>(#{count})</small>" if ! pique?
    return "#{nom}<sup title='exclusif'>&nbsp;x</sup> #{c}" if exclusif?
    "#{nom} #{c}"
   end

  def count
    evaluation.count  
  end

  def selected?
    User.current.profile.filtres.include? self
  end

  def json()
    #logger.info("GROUPE:#{data} #{id}")
    selected= User.current.profile.filtres.include? self
    if  User.current.profile.vues_active!=nil && User.current.profile.vues_active.include?(data.groupe.to_i)
      actif = true
    else
      actif = false
    end
    zid=id
    zid="separator#{nom}#{data.groupe}" if nom==Vue::AFTER || nom==Vue::BEFORE
    { :id=>zid, :cell => [ selected, ApplicationController.helpers.format_objet(self), data.groupe, writable?(false),pictogramme,actif  ]   }
  end
  
  
  
end