class Perspective  < Objet
  
   attr_accessible :contexte
   
   ENTITE=0
   CONTEXTUEL=1   # Attention utilisé dans perspective .js 
   CONTEXTES=[ENTITE,CONTEXTUEL]
   
  
   def initialize(attributes = {})
    super
    self.categorie=PERSPECTIVE
    self.nom="Nouveau"
    self.description="Description"
    self.data=[]
    self.contexte=ENTITE
   end

   # === CURRENTS
  def self.currents
    Objet.filtrer(Perspective.all(:conditions => ["categorie = ?",PERSPECTIVE]) )
  end
  
  def self.currentsContextuel
    Objet.filtrer(Perspective.all(:conditions => ["categorie = ? AND contexte = ?",PERSPECTIVE,CONTEXTUEL]) )
  end
  
  def export(controller)
    file = Tempfile.new([id, '.txt'])
    infos={nom: nom, description: description, contexte: contexte, data: data}
    File.open(file,'w') do |f|
      f.puts infos.to_json
    end
    controller.send_file file.path, :filename => "perspective_#{nom}.txt"
  end
  
  def self.import(content)
    infos=ActiveSupport::JSON.decode(content)  
    p=Perspective.new
    p.nom=infos["nom"]
    p.description=infos["description"]
    p.contexte=infos["contexte"]
    p.data=infos["data"]
    p.save
    p
  end
  
  def modeEntite?
    contexte==ENTITE 
  end
  
  def modeContextuel?
    contexte==CONTEXTUEL 
  end
  
  def uiDisplay
    "<span class='contexte_#{contexte}' title='#{ApplicationController.helpers.format_contexte(contexte)}'>&nbsp;</span>"+nom
  end
  
  def json()
    selected= User.current.profile.filtres.include? self
    { :id=>id, :cell => [ selected, ApplicationController.helpers.format_objet(self), "", writable?,""  ]   }
  end

  

end