class Profile < ActiveRecord::Base

  attr_accessible :perspective_entite,:perspective_contextuelle,:vues_order,:vues_active
  has_and_belongs_to_many :filtres
  has_one  :user

  serialize :options
  serialize :vues_order
  serialize :vues_active

  SHOW_SHARED="SHOW_SHARED"
  EDIT_MODE="EDIT_MODE"
  FILTRE_FAST="FILTRE_FAST"
  FILTRE_MODE="FILTRE_MODE"
  FILTRE_EXC="FILTRE_EXC"
  SET_GPS="SET_GPS"
  MAP_ZOOM="MAP_ZOOM"
  MAP_CENTER="MAP_CENTER"
  COMPOSANTE="COMPOSANTE"
  OPTIONS=[SHOW_SHARED,EDIT_MODE,FILTRE_FAST,FILTRE_EXC,SET_GPS,MAP_ZOOM,MAP_CENTER,FILTRE_MODE,COMPOSANTE]

  before_create do
    self.options={"SHOW_SHARED" => true,"EDIT_MODE"=> false,"FILTRE_FAST" => true,"SET_GPS" => false,
                  "MAP_CENTER" => -1, "MAP_ZOOM" => 11,"FILTRE_MODE"=>0,"COMPOSANTE"=>1
    }
  end


  def getFiltres
    filtres.select {|f| f.categorie == Objet::FILTRE}
  end
  
  def getFiltresVue
    filtres.select {|f| f.categorie == Objet::FILTRE_VUE}
  end
  
  
  def affecterUneperspectiveParDefaut(p)
    if p.modeEntite?
      update_attributes({:perspective_entite => p.id})  
    end
    
    if p.modeContextuel?
      update_attributes({:perspective_contextuelle => p.id})
    end
 
  end

  # Perspective par defaut 
  def perspective=(p)
    self.perspective_entite=p.id
  end

  def perspective
     return nil if self.perspective_entite==nil
     Perspective.find_by_id(self.perspective_entite)
  end
  # =============================
  
  # Perspective par defaut du mode contextuel
  def contextualPerspective=(p)
    self.perspective_entite=p.id
  end

  def contextualPerspective
     return nil if self.perspective_contextuelle==nil
     Perspective.find_by_id(self.perspective_contextuelle)
  end
  
  def currentPerspectiveContexte
    p=contextualPerspective
    if p==nil
      p=Perspective.currentsContextuel.first  
    end
    return p.id if p !=nil
    -1
  end
  # =============================
  


  def has(key)
    v=get(key)
    return true if v == true || v =~ (/(true|t|yes|y|1)$/i)
    false
  end

  def get(key)
    return options[key] if options.include? key
    false
  end

  def set(key,value)
    return false if ! OPTIONS.include? key
    options[key] = value
    true
  end

end
