class Right < ActiveRecord::Base

  DROITS=[Permission::DENY,Permission::READ]

  belongs_to :user
  belongs_to :objet
  attr_accessible :droit

  before_save do
    self.objet.writable? false
  end


  def droitForCurrentUser?(d)
      return false if d>droit
      User.current.id == user.id || User.current.groups.exists?(user)
  end

  def isDeletable?
    droit==Permission::DELETE ||  User.current.admin?
  end

  def isWritable?
    (droit==Permission::WRITE || isDeletable?  ) && ! isDeny?
  end

  def isModifiable?
    (droit==Permission::MODIFY)
  end

  def isReadable?
    (droit==Permission::READ || isModifiable?  ) && ! isDeny?
  end

  def isDeny?
    droit==Permission::DENY
  end

  def to_json()
    { :id=>id, :cell => [ user.uid,  ApplicationController.helpers.format_droit(droit) ]   }
  end

end
