module Rapports
  
  

  
  class ScriptData
    attr_accessor :language, :usage, :script 
    attr_accessor :serveurs, :byserver
    
    PYTHON="python"
    SHELL="shell"
    LANGUAGES=[SHELL,PYTHON]

    def initialize()
      self.language=SHELL
      self.usage=""
      self.script=""
      self.serveurs=[]
      self.byserver=false
    end
    

    
    def findLanguage(line)
      self.language= ScriptData.getLanguage(line)
    end
    
    # Retourne l'interpreteur d'un script
    # la 1er ligne d'un script commence par #!
    # Ex: #!/bin/sh
    def self.getInterpreteur(line)
      line.gsub("#!","")  
    end

    def self.getLanguage(line)

      LANGUAGES.each do |l|
        if line.include? l
          return l
          break
        end
      end
    end
    
  end
  
  
  class FiltreData
    
    attr_accessor :selected, :pictogramme, :expression , :groupe, :composantes 

    def initialize()
      self.selected=true
      self.pictogramme="MapMarker/MapMarker_Marker_Outside_Azure.png"
      self.expression="true"
      self.groupe="Tous"
    end

    def composantes
      ret=[]
      a=expression.scan(/{([0-9,A-Z,a-z,.,-,_,:,~,\/]*)}/)
      a.each do |c|
        c=Composante.getComposanteFromFullname(c[0],true)
        ret<<c if c!=nil
      end
      ret
    end

    def evaluer(entity_uid)

      r=expression
      a=expression.scan(/{([0-9,A-Z,a-z,.,-,_,:,~,\/]*)}/)
      a.each do |c|
          #valeur=Value.getValue(entity_uid,Composante.getComposanteFromFullname(c[0]))
          value=Value.getValueFromFullname(entity_uid,c[0])
          if value == nil
            return false #Value::NOTEXIST
          elsif (value.is_a? String) && (value == Value::FORBIDDEN || 
                                         value == Value::NOTFOUND || 
                                         value == Value::NOTEXIST)
            return value
          end
          
          r=RapportColumn.remplacer(r,c[0],value)

           
      end
      
      #puts ("==== ==== EVALUER #{expression} => #{r} ")
       t=Thread.start {
            $SAFE=4
            eval(r)
       }
       return false if t.value==nil
       t.value
       #puts "#{expression} => #{r} = #{t.value}"
       #t.value
       
    end
    
  end
  

  class RapportColumn
    attr_accessor :nom, :format, :id

    TAG_SYNTAX=/{([0-9,A-Z,a-z,.,-,_,:,~,\/]*)}/

    # Le format est une composante accessible en modification
    def editable?
      if format =~ /^"?{[0-9,A-Z,a-z,.,-,_,:,~,\/]*}"?$/
        a=format.scan(TAG_SYNTAX)
        composante=Composante.getComposanteFromFullname(a[0][0],true)
        return false if composante==nil
        return composante.isModifiable?
      end
      false
    end
    
    def composante
      if format =~ /^"?{[0-9,A-Z,a-z,.,-,_,:,~,\/]*}"?$/
        a=format.scan(TAG_SYNTAX)
        composante=Composante.getComposanteFromFullname(a[0][0])
        return composante
      end
      nil  
    end

    def formater(entity_uid)
      RapportColumn.formater(entity_uid,format)
    end

    def self.formater(entity_uid,format,evaluer=true,composante=nil,currentValue=nil,masteruid=nil)

     #puts "FORMAT:#{format} "

      if format.first=="="
        format = format[1..-1]
        evaluer=true
      end

      r=format
      a=format.scan(TAG_SYNTAX)
      a.each do |c|

        if c[0].first=="~"
          c[0] = c[0][1..-1]
          appformatter=true
        end

        value=Value.getValueFromFullname(entity_uid,c[0],composante,currentValue,masteruid)
       
        if appformatter
          if value!=nil && value.is_a?(Value)
            r=RapportColumn.remplacer(r,"~"+c[0],value.format())
          else
            r=RapportColumn.remplacer(r,"~"+c[0],value)
          end
        else
          r=RapportColumn.remplacer(r,c[0],value)
        end

      end
      # Demande d'évaluation de l'expression
      if evaluer
        begin
          t=Thread.start {
            $SAFE=4
            eval(r)
          }
          #puts "#{format} => #{r} = #{t.value}"
          r=t.value
        rescue Exception => exc
          puts "#{format} => #{r}"
          return false
        end 
      end # Fin d'évaluation
      
      r

    end

    def self.remplacer(r,sujet,value)
      
      if value == nil
        v=Value::NOTEXIST
      elsif value.is_a? String
        v=value
      elsif value.is_a? Integer
        v=value.to_s
      else
        v=value.valeur
      end
      ret=r.gsub("{"+sujet+"}",v)
      #puts "[#{r}] /s{#{sujet}} /r[#{v}] =>[#{ret}]"
      
      ret
    end

  end




end