# -*- coding: utf-8 -*-
# encoding: utf-8

# 1er groupe a créer est le groupe admin
Group.create(:nom => "", :prenom => "Administrateurs", :uid =>  Group::ADMIN)
User.current=Group.admin

Group.create(:nom => "", :prenom => "Tout le monde", :uid => Group::ALL, :special =>true )
Group.create(:nom => "", :prenom => "Personne", :uid =>  Group::NOBODY, :special =>true)
Group.create(:nom => "", :prenom => "Manager", :uid =>  Group::MANAGER, :special =>true)
Group.create(:nom => "", :prenom => "Invité", :uid => Group::GUEST, :special =>true)
Group.create(:nom => "", :prenom => "Utilisateur CAS", :uid => Group::CAS_USER, :special =>true , :dynamic => true)
Group.create(:nom => "", :prenom => "Positionnement GPS", :uid => Group::GPS, :special =>true)

# Création du compte administrateur (Mot de passe par défaut $admin!)
administrateur=User.create(:nom => "", :prenom => "Administrateur", :uid => "admin" ,:password=> "$admin!")
administrateur.groups << Group.admin
administrateur.groups << Group.gps
administrateur.save

User.current=administrateur

# Création de la configuration
Appconfig.init()
Appconfig.createMethods()

include Importations

# Maitre
infoetabs = Master.createMaster('Informations Etablissements')
infoetabs.permission(Group.admin,Permission::WRITE)
infoetabs.permission(Group.all,Permission::READ)
infoetabs.save

ident =  Composante.create(:tag => 'identite', :name => 'Identité',:parent_id => infoetabs.id, :categorie => Composante::FOLDER)
Composante.create(:tag => 'uaj', :name => 'UAJ',:parent_id => ident.id, :flaguid => true)
Composante.create(:tag => 'libelle', :name => 'libelle',:parent_id => ident.id)
Composante.create(:tag => 'type', :name => 'Type',:parent_id => ident.id)
Composante.create(:tag => 'adresse', :name => 'Adresse',:parent_id => ident.id)
Composante.create(:tag => 'ville', :name => 'Ville',:parent_id => ident.id)
Composante.create(:tag => 'cp', :name => 'Code postal',:parent_id => ident.id)
Composante.create(:tag => 'tel', :name => 'Téléphone',:parent_id => ident.id)
Composante.create(:tag => 'fax', :name => 'Fax',:parent_id => ident.id)
Composante.create(:tag => 'remarques', :name => 'Remarques',:parent_id => ident.id)
Composante.create(:tag => 'responsable', :name => 'Responsable',:parent_id => ident.id)
Composante.create(:tag => 'mail', :name => 'Mail',:parent_id => ident.id)
ident.permission(Group.admin,Permission::WRITE)
ident.permission(Group.all,Permission::READ)
ident.save

# Script permettant de récupérer les infos établissements depuis Zephir
script=Importations::script("data/zephir/RecupServeursFromZephir.py",
                     "RecupEtabsFromZephir.py",
                     "Récupération des informations d'établissement depuis zephir",false,[infoetabs])
infoetabs.serveurTask.update_attributes({:commande => "#{script.id}",:tfrequence=>5,:tunit=>Serveur::MINUTE } )
infoetabs.save

# Coordonnées GPS
gps =  Composante.create(:tag => 'gps', :name => 'Coordonnées GPS',:parent_id => infoetabs.id, :categorie => Composante::FOLDER)
Composante.create(:tag => 'lon_precis', :name => 'Longitdue (Précise)',:parent_id => gps.id)
Composante.create(:tag => 'lat_precis', :name => 'Latitude (Précise)',:parent_id => gps.id)
Composante.create(:tag => 'lon_aprox', :name => 'Longitude  (Approximative)',:parent_id => gps.id)
Composante.create(:tag => 'lat_aprox', :name => 'Latitude  (Approximative)',:parent_id => gps.id)
gps.permission(Group.find_by_uid("@gps"),Permission::MODIFY)
gps.permission(Group.all,Permission::READ)
gps.save

# ZEPHIR =================================================
zephir=Master.createServeur("ZEPHIR","Serveur ZEPHIR")
Composante.create(:tag => 'site', :name => 'Site',:parent_id => zephir.id,:flaguid => true)
Composante.create(:tag => 'ip', :name => 'Adresse IP',:parent_id => zephir.id)
Composante.create(:tag => 'user', :name => 'Identifiant zephir',:parent_id => zephir.id)
Composante.create(:tag => 'password', :name => 'Mot de passe',:parent_id => zephir.id,:categorie=>Composante::PASSWORD)
zephir.permission(Group.admin,Permission::WRITE)
zephir.permission(Group.all,Permission::DENY)
zephir.save

Importations::csv("data/.zephir","±") # Nécessaire de connexion à Zephir
Appconfig.ZEPHIR="true"
Appconfig.ZEPHIR_HOST=Value.getValueFromFullname("RECTORAT","ZEPHIR.ip").valeur;
Appconfig.ZEPHIR_LOGIN=Value.getValueFromFullname("RECTORAT","ZEPHIR.user").valeur;
Appconfig.ZEPHIR_PASSWORD=Value.getValueFromFullname("RECTORAT","ZEPHIR.password").valeur;

Appconfig.GEN_ALLOW_GUEST="true"

#Script de récupération de toutes les configurations/agents sur Zephir
script=Importations::script("data/zephir/ServerConf.py",
                            "Serveurs.py",
                            "Récupération des informations des serveurs sur zephir",false)
zephir.serveurTask.update_attributes(:commande=>"#{script.id}",:tfrequence=>3,:tunit=>Serveur::MINUTE )

# Script qui va récupérer la configuration/agents pour un serveur
zephir_measure_script=Importations::script("data/zephir/zephirmeasure.py",
                                           "zephirmeasure.py",
                                           "Récupération des états individuels des serveurs. Ces états devront être préalablement récupérés via Serveurs.py\nParamètre: <identifiant zephir>",true,[zephir])

# Les utilisateurs ayant le droit d'enregistrement sur Zephir
zenreg=Group.create(:nom => "Zephir", :prenom => "Enregistrement", :uid => "@ZENREGISTREMENT", :dynamic => true )
zread=Group.create(:nom => "Zephir", :prenom => "Lecture", :uid => "@ZREAD", :dynamic => true )



# Fonction permettant de créer la base d'un serveur
def CreateModuleEole(type,script,delay)
  serveur=Master.createServeur(type,"Serveur #{type}")
  Composante.create(:tag => 'zeph_id', :name => 'Identifiant zephir',:parent_id => serveur.id,:flaguid => true)
  Composante.create(:tag => 'libelle', :name => 'Libellé',:parent_id => serveur.id)
  Composante.create(:tag => 'modulename', :name => 'Nom du module',:parent_id => serveur.id)
  Composante.create(:tag => 'zeph_variante', :name => 'Nom de la variante',:parent_id => serveur.id)
  Composante.create(:tag => 'zeph_module_actuel', :name => 'Identifiant du module',:parent_id => serveur.id)
  conf=Composante.create(:tag => 'configuration', :name => 'Configuration', :parent_id => serveur.id, :categorie => Composante::FOLDER)
  
  serveur.serveurTask.update_attributes(:commande=>"#{script.id}",:arguments => "{zeph_id}",
                                        :tfrequence=>delay,:tunit=>Serveur::MINUTE, :byetab => true )
  
  Importations::sentinellev2("data/importations/include/STATUS_#{type}.xml",serveur)
  Importations::dicos("data/importations/dicos/#{type}",conf)
  conf.permission(Group.admin,Permission::WRITE)
  conf.permission(Group.find_by_uid("@ZENREGISTREMENT"),Permission::MODIFY)
  conf.permission(Group.all,Permission::DENY)
  
  serveur.permission(Group.find_by_uid("@ZREAD"),Permission::READ)
  serveur.permission(Group.all,Permission::DENY)

  script.serveurs << serveur
  script.save
  
  serveur
end

# AMON ======================================================
amon=CreateModuleEole("AMON",zephir_measure_script,5)


# HORUS =================================================
horus=CreateModuleEole("HORUS",zephir_measure_script,11)


# SCRIBE ====================================================
scribe=CreateModuleEole("SCRIBE",zephir_measure_script,7)


capacities=Composante.find_all_by_categorie("CAPACITYDISK")
capacities.each do |composante|
  composante.error_condition="{:percent} > 80" 
  composante.error_message="Le pourcentage d'occupation de la partition <b>{:name}</b> est > à 80%, il reste {:available}Mo de disponible"
  composante.save
end


p=Importations.perspective("data/importations/objets/perspective_Informations générales.txt")
p.addRight(zenreg,Permission::READ)

p=Importations.perspective("data/importations/objets/perspective_Assistance.txt")
p.addRight(zenreg,Permission::READ)

p=Importations.perspective("data/importations/objets/perspective_Informations.txt")
p.addRight(Group.all,Permission::READ)


# ==================================================================
# Importation des données établissements/serveurs depuis Zephir
User.current=nil # Afin d'éxécuter les scripts avec les bons droits

# Récupération des infos Zephir
infoetabs.serveurTask.execute       # Récupération des établissements et identifiant des serveurs
zephir.serveurTask.execute          # Récupération des états des serveurs

# Chargement des coordonnées GPS
Importations::csv("data/importations/etabs.gps",",")

User.current=administrateur
# ==================================================================

# Création des menus
include Rails.application.routes.url_helpers
default_url_options[:host] = "localhost" # Laisser à localhost, 
                                         # sera remplacer a la fin de la créaion des menus 

# Accueil : /index
accueil=Menu.create(tag: "accueil", url: url_for( controller: "main", action: "accueil"), nom: "Accueil")
accueil.users << Group.guest # invité (non connectes)
accueil.users << Group.all   # Tous les connectés
accueil.save

# Gestion
gestion=Menu.create(tag: "gestion", url: url_for( controller: "composantes" ), nom: "Gérer" )
gestion.users << Group.manager
gestion.users << Group.admin
gestion.save


gestion.rubriques << Rubrique.create(tag: "configuration", url: url_for( controller: "administration", action: "configuration" ), nom: "Configuration", famille: "Administration")

gestion.rubriques<< Rubrique.create(tag: "users", url: url_for( controller: "users", action: "manage" ), nom: "Gérer les utilisateurs", famille: "Administration")

gestion.rubriques<< Rubrique.create(tag: "composantes", url: url_for( controller: "composantes" ), nom: "Créer / Modifier les composantes", famille: "Gestion des Composantes")
gestion.rubriques<< Rubrique.create(tag: "scripts", url: url_for( controller: "administration", action: "scripts_accueil" ), nom: "Gérer les scripts", famille: "Gestion des Composantes")
gestion.rubriques<< Rubrique.create(tag: "importations", url: url_for( controller: "importation" ), nom: "Peupler (Importation csv)", famille: "Gestion des Composantes")


# Rapports
rapports=Menu.create(tag: "rapports", url: url_for( controller: "rapports" ), nom: "Rapports")
rapports.users << Group.all
rapports.save

r=Rubrique.create(tag: "create", url: url_for( controller: "rapports", action: "create" ), nom: "Créer un rapport")
r.save
rapports.rubriques<< r

r=Rubrique.create(tag: "manage", url: url_for( controller: "rapports", action: "manage" ), nom: "Gérer les rapports")
r.save
rapports.rubriques<< r

Menu.all.each do |m|
  m.url=m.url.gsub("http://localhost","")
  m.save
end


gAll=Group.all

# Création des rapports  ===============================================
rapport=Rapport.new
rapport.nom="Coordonnées GPS"
rapport.description="Coordonnées GPS des établissements"
rapport.addColumn(Master.composanteKey.tag)
rapport.addColumn("libelle")
rapport.addColumn("lon_precis")
rapport.addColumn("lat_precis")
rapport.addRight(gAll,Permission::READ)
rapport.save

rapport=Rapport.new
rapport.nom="Etablissements"
rapport.description="Liste des établissements"
rapport.addColumn(Master.composanteKey.tag)
rapport.addColumn("libelle")
rapport.addColumn("type")
rapport.addColumn("adresse")
rapport.addColumn("cp")
rapport.addColumn("ville")
rapport.addColumn("tel")
rapport.addRight(gAll,Permission::READ)
rapport.save


# =====================================================================


# Création de filtres/vues  ===============================================

puts "Création de la vue : Type d'établissements"

vue=Vue.create
vue.nom= "Type d'établissements"
filtre=Filtre.create
filtre.nom= "Collèges"
filtre.expression='"{infosetabs.type}" == "CLG"'
filtre.pictogramme="MapMarker/MapMarker_Marker_Outside_Azure.png"
vue.filtres << filtre
gAll.profile.filtres << filtre
administrateur.profile.filtres << filtre

filtre=Filtre.create
filtre.nom= "Lycées"
filtre.expression='"{infosetabs.type}" == "LYC"'
filtre.pictogramme="MapMarker/MapMarker_Marker_Outside_Pink.png"
vue.filtres << filtre
gAll.profile.filtres << filtre
administrateur.profile.filtres << filtre

filtre=Filtre.create
filtre.nom= "Lycées Pro"
filtre.expression='"{infosetabs.type}" == "LP"'
filtre.pictogramme="MapMarker/MapMarker_Marker_Outside_Chartreuse.png"
vue.filtres << filtre
gAll.profile.filtres << filtre
administrateur.profile.filtres << filtre

gAll.profile.vues_active=[vue.id] ; gAll.profile.save
administrateur.profile.vues_active=[vue.id] ; administrateur.profile.save

vue.addRight(gAll,Permission::READ)

vue.save!
# ===========================================================================



# Création de filtres/vues  ===============================================

puts "Création de la vue : Erreurs"

vue=Vue.create
vue.nom= "Erreurs"

filtre=Filtre.create
filtre.nom= "AMON"
filtre.expression='{AMON:nberreurs} > 0'
filtre.pictogramme="symboles/warning_red.png"
vue.filtres<<filtre

filtre=Filtre.create
filtre.nom= "HORUS"
filtre.expression='{HORUS:nberreurs} > 0'
filtre.pictogramme="symboles/warning.png"
vue.filtres<<filtre

filtre=Filtre.create
filtre.nom= "SCRIBE"
filtre.expression='{SCRIBE:nberreurs} > 0'
filtre.pictogramme="symboles/warning_blue.png"
vue.filtres<<filtre

filtre=Filtre.create
filtre.nom= "OK"
filtre.expression=''               # si vide, est utilisé par dépit (ie: aucun filtre précédent ne matche)
filtre.pictogramme="led/GREEN.png"
vue.filtres << filtre

vue.save!
# ===========================================================================

puts "====================================================="
puts "Initialisation terminée"

