#!/bin/sh

SENTINELLE_HOME="/usr/share/sentinelle"
SENTINELLE_APP="$SENTINELLE_HOME/alizes"

# ===============================================================
# Installation de SentinelleOnRails sur une ubuntu 12.04
# Installation de l'application dans $SENTINELLE_APP
# ===============================================================

# Installation de RVM: Ruby Version Manager
sudo apt-get update
sudo apt-get install curl
curl -L get.rvm.io | bash -s stable
source ~/.rvm/scripts/rvm
rvm requirements
rvmsudo apt-get install build-essential openssl libreadline6 libreadline6-dev curl git-core zlib1g zlib1g-dev libssl-dev libyaml-dev libsqlite3-dev sqlite3 libxml2-dev libxslt-dev autoconf libc6-dev ncurses-dev automake libtool bison subversion

# Utilisation de ruby 1.9.3
rvm install 1.9.3
rvm use 1.9.3 --default
rvm rubygems current

# Installation de rails
gem install rails

# Installation des libs (mysql,imagemagick)
sudo apt-get install mysql-server
sudo apt-get install libmysqld-dev
sudo apt-get install imagemagick
sudo apt-get install libmagick++-dev

# Installation de passenger
sudo apt-get install libcurl4-openssl-dev
sudo apt-get install apache2-prefork-dev

gem install passenger
passenger-install-apache2-module

# =================================================================
# FICHERS DE CONFIGURATION
# =================================================================

# Génération de /etc/apache2/httpd.conf ( A templatiser)
sudo echo "
LoadModule passenger_module $SENTINELLE_HOME/.rvm/gems/ruby-1.9.3-p194/gems/passenger-3.0.17/ext/apache2/mod_passenger.so
PassengerRoot $SENTINELLE_HOME/.rvm/gems/ruby-1.9.3-p194/gems/passenger-3.0.17
PassengerRuby $SENTINELLE_HOME/.rvm/wrappers/ruby-1.9.3-p194/ruby  " >> /etc/apache2/httpd.conf

# Génération de /etc/apache2/sites-available/passenger.conf ( A templatiser)
sudo echo "
<VirtualHost *:443>
      ServerName sentinelle3.ac-reunion.fr

      SSLEngine on
      SSLCertificateFile    /etc/ssl/certs/ssl-cert-snakeoil.pem
      SSLCertificateKeyFile /etc/ssl/private/ssl-cert-snakeoil.key

      DocumentRoot $SENTINELLE_APP/public
      <Directory   $SENTINELLE_APP/public>
         # This relaxes Apache security settings.
         AllowOverride all
         # MultiViews must be turned off.
         Options -MultiViews
      </Directory>
</VirtualHost>
" > /etc/apache2/sites-available/passenger.conf

# Génération du code d'accès a Zephir
echo "ZEPHIR.site±ZEPHIR.ip±ZEPHIR.user±ZEPHIR.password" > $SENTINELLE_APP/data/.zephir
echo "RECTORAT±$ZEPHIR_HOST±$ZEPHIR_LOGIN±$ZEPHIR_PWD" >> $SENTINELLE_APP/data/.zephir


a2enmod ssl
sudo chown -R sentinelle.www-data $SENTINELLE_APP
chmod -R 774 .

sudo /etc/init.d/apache2 restart

